Index: code/branches/unity_build/src/libraries/core/Core.h
===================================================================
--- code/branches/unity_build/src/libraries/core/Core.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/Core.h	(revision 8672)
@@ -45,6 +45,4 @@
 
 #include <string>
-#include <loki/ScopeGuard.h>
-
 #include "util/DestructionHelper.h"
 #include "util/Singleton.h"
Index: code/branches/unity_build/src/libraries/core/CoreIncludes.h
===================================================================
--- code/branches/unity_build/src/libraries/core/CoreIncludes.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/CoreIncludes.h	(revision 8672)
@@ -80,5 +80,4 @@
 #include "util/Debug.h"
 #include "Identifier.h"
-#include "SubclassIdentifier.h"
 #include "ClassFactory.h"
 #include "ObjectList.h"
Index: code/branches/unity_build/src/libraries/core/EventIncludes.h
===================================================================
--- code/branches/unity_build/src/libraries/core/EventIncludes.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/EventIncludes.h	(revision 8672)
@@ -37,4 +37,6 @@
 
 #include "CorePrereqs.h"
+
+#include "Event.h"
 #include "XMLPort.h"
 #include "command/Executor.h"
Index: code/branches/unity_build/src/libraries/core/LuaState.h
===================================================================
--- code/branches/unity_build/src/libraries/core/LuaState.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/LuaState.h	(revision 8672)
@@ -48,5 +48,4 @@
 #include <vector>
 #include <boost/shared_ptr.hpp>
-#include <loki/ScopeGuard.h>
 
 #include "ToluaInterface.h"
Index: code/branches/unity_build/src/libraries/core/ObjectListBase.h
===================================================================
--- code/branches/unity_build/src/libraries/core/ObjectListBase.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/ObjectListBase.h	(revision 8672)
@@ -41,7 +41,5 @@
 
 #include "CorePrereqs.h"
-
 #include <vector>
-#include "OrxonoxClass.h"
 
 namespace orxonox
Index: code/branches/unity_build/src/libraries/core/OrxonoxClass.h
===================================================================
--- code/branches/unity_build/src/libraries/core/OrxonoxClass.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/OrxonoxClass.h	(revision 8672)
@@ -45,8 +45,8 @@
 
 #include "CorePrereqs.h"
-#include "Super.h"
 
 #include <set>
 #include <vector>
+#include "Super.h"
 
 /**
Index: code/branches/unity_build/src/libraries/core/Super.h
===================================================================
--- code/branches/unity_build/src/libraries/core/Super.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/Super.h	(revision 8672)
@@ -73,7 +73,5 @@
 
 #include "CorePrereqs.h"
-
 #include "util/Debug.h"
-#include "Event.h"
 
 ///////////////////////
Index: code/branches/unity_build/src/libraries/core/ToluaInterface.h
===================================================================
--- code/branches/unity_build/src/libraries/core/ToluaInterface.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/ToluaInterface.h	(revision 8672)
@@ -39,4 +39,5 @@
 #include "CorePrereqs.h"
 #include <boost/preprocessor/cat.hpp>
+#include <loki/ScopeGuard.h>
 
 // Macro for declaring a tolua interface of a library/module
Index: code/branches/unity_build/src/libraries/core/ViewportEventListener.h
===================================================================
--- code/branches/unity_build/src/libraries/core/ViewportEventListener.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/ViewportEventListener.h	(revision 8672)
@@ -30,7 +30,7 @@
 #define _ViewportEventListener_H__
 
+#include "CorePrereqs.h"
+
 #include "util/OgreForwardRefs.h"
-
-#include "CorePrereqs.h"
 #include "OrxonoxClass.h"
 
Index: code/branches/unity_build/src/libraries/core/command/Functor.h
===================================================================
--- code/branches/unity_build/src/libraries/core/command/Functor.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/command/Functor.h	(revision 8672)
@@ -114,7 +114,7 @@
 #define _Functor_H__
 
+#include "core/CorePrereqs.h"
+
 #include <typeinfo>
-
-#include "core/CorePrereqs.h"
 
 #include "util/Debug.h"
Index: code/branches/unity_build/src/libraries/core/command/IOConsoleWindows.h
===================================================================
--- code/branches/unity_build/src/libraries/core/command/IOConsoleWindows.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/command/IOConsoleWindows.h	(revision 8672)
@@ -39,5 +39,4 @@
 #include <sstream>
 #include <string>
-#include <vector>
 #include "util/Singleton.h"
 #include "Shell.h"
Index: code/branches/unity_build/src/libraries/core/input/InputManager.h
===================================================================
--- code/branches/unity_build/src/libraries/core/input/InputManager.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/input/InputManager.h	(revision 8672)
@@ -33,5 +33,4 @@
 
 #include <map>
-#include <set>
 #include <string>
 #include <vector>
Index: code/branches/unity_build/src/libraries/core/input/InputPrereqs.h
===================================================================
--- code/branches/unity_build/src/libraries/core/input/InputPrereqs.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/input/InputPrereqs.h	(revision 8672)
@@ -41,5 +41,4 @@
 #include <ois/OISKeyboard.h>
 #include <ois/OISMouse.h>
-#include <ois/OISJoyStick.h>
 #include "util/OrxEnum.h"
 
Index: code/branches/unity_build/src/libraries/core/input/JoyStick.h
===================================================================
--- code/branches/unity_build/src/libraries/core/input/JoyStick.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/input/JoyStick.h	(revision 8672)
@@ -34,4 +34,5 @@
 #include <string>
 #include <vector>
+#include <ois/OISJoyStick.h>
 #include "InputDevice.h"
 
Index: code/branches/unity_build/src/libraries/core/input/JoyStickQuantityListener.h
===================================================================
--- code/branches/unity_build/src/libraries/core/input/JoyStickQuantityListener.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/input/JoyStickQuantityListener.h	(revision 8672)
@@ -36,4 +36,6 @@
 
 #include "InputPrereqs.h"
+
+#include <vector>
 #include "core/OrxonoxClass.h"
 
Index: code/branches/unity_build/src/libraries/core/input/KeyBinderManager.h
===================================================================
--- code/branches/unity_build/src/libraries/core/input/KeyBinderManager.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/input/KeyBinderManager.h	(revision 8672)
@@ -34,5 +34,4 @@
 #include <map>
 #include <string>
-#include <boost/shared_ptr.hpp>
 
 #include "util/Singleton.h"
Index: code/branches/unity_build/src/libraries/core/input/KeyDetector.h
===================================================================
--- code/branches/unity_build/src/libraries/core/input/KeyDetector.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/input/KeyDetector.h	(revision 8672)
@@ -32,5 +32,4 @@
 #include "InputPrereqs.h"
 
-#include <boost/shared_ptr.hpp>
 #include "util/Singleton.h"
 #include "KeyBinder.h"
Index: code/branches/unity_build/src/libraries/core/input/Keyboard.h
===================================================================
--- code/branches/unity_build/src/libraries/core/input/Keyboard.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/core/input/Keyboard.h	(revision 8672)
@@ -31,6 +31,4 @@
 
 #include "InputPrereqs.h"
-
-#include "InputHandler.h"
 #include "InputDevice.h"
 
Index: code/branches/unity_build/src/libraries/network/WANDiscoverable.h
===================================================================
--- code/branches/unity_build/src/libraries/network/WANDiscoverable.h	(revision 8671)
+++ code/branches/unity_build/src/libraries/network/WANDiscoverable.h	(revision 8672)
@@ -28,5 +28,5 @@
 
 #include "NetworkPrereqs.h"
-// #include "core/OrxonoxClass.h"
+#include "core/OrxonoxClass.h"
 #include "core/CoreIncludes.h"
 #include "MasterServerComm.h"
Index: code/branches/unity_build/src/modules/objects/eventsystem/EventFilter.cc
===================================================================
--- code/branches/unity_build/src/modules/objects/eventsystem/EventFilter.cc	(revision 8671)
+++ code/branches/unity_build/src/modules/objects/eventsystem/EventFilter.cc	(revision 8672)
@@ -30,4 +30,5 @@
 
 #include "core/CoreIncludes.h"
+#include "core/Event.h"
 #include "core/XMLPort.h"
 #include "EventName.h"
Index: code/branches/unity_build/src/modules/objects/eventsystem/EventListener.cc
===================================================================
--- code/branches/unity_build/src/modules/objects/eventsystem/EventListener.cc	(revision 8671)
+++ code/branches/unity_build/src/modules/objects/eventsystem/EventListener.cc	(revision 8672)
@@ -30,4 +30,5 @@
 
 #include "core/CoreIncludes.h"
+#include "core/Event.h"
 #include "core/XMLPort.h"
 
Index: code/branches/unity_build/src/orxonox/weaponsystem/WeaponSystem.cc
===================================================================
--- code/branches/unity_build/src/orxonox/weaponsystem/WeaponSystem.cc	(revision 8671)
+++ code/branches/unity_build/src/orxonox/weaponsystem/WeaponSystem.cc	(revision 8672)
@@ -30,4 +30,5 @@
 
 #include "core/CoreIncludes.h"
+#include "core/SubclassIdentifier.h"
 #include "worldentities/pawns/Pawn.h"
 