Index: code/branches/presentation/data/levels/presentationFS11.oxw
===================================================================
--- code/branches/presentation/data/levels/presentationFS11.oxw	(revision 8673)
+++ code/branches/presentation/data/levels/presentationFS11.oxw	(revision 8679)
@@ -93,5 +93,5 @@
     </SimpleNotification>
 
-    <!-- This is a model of Earth: mass=EarthMass/1000 and radius=EarthRadius[km]*10 -->
+    <!-- EARTH -->
     <Planet
       position="80500,0,0"
@@ -143,4 +143,12 @@
         </events>
     </ParticleSpawner>
+    <StaticEntity collisionType = "static" position = "-50,50,-125" scale=1 >
+      <attached>
+        <Model position="0,0,0" scale="2" mesh="ast1.mesh" />
+      </attached>
+      <collisionShapes>
+        <SphereCollisionShape radius="8" />
+      </collisionShapes>
+    </StaticEntity>
        
     <SimpleNotification message="A particle effect by Tibor" >
@@ -170,27 +178,44 @@
     </Script>
 
-    <SpawnPoint position="50,0,0" lookat="-2,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
+    <SpawnPoint position="100,0,0" lookat="-2,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
         <events>
             <activity>
-                <EventListener event=spawndelaytrigger1 />
+                <EventListener event=spawnpointtrigger />
             </activity>
         </events>
     </SpawnPoint>
 
-    <SpawnPoint position="0,-50,0" lookat="-2,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
+    <SpawnPoint position="0,-100,0" lookat="-2,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
         <events>
             <activity>
-                <EventListener event=spawndelaytrigger1 />
+                <EventListener event=spawnpointtrigger />
             </activity>
         </events>
     </SpawnPoint>
 
-    <SpawnPoint position="0,0,50" lookat="-2,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
+    <SpawnPoint position="0,0,100" lookat="-2,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff active="false" >
         <events>
             <activity>
-                <EventListener event=spawndelaytrigger1 />
+                <EventListener event=spawnpointtrigger />
             </activity>
         </events>
     </SpawnPoint>
+
+    <Trigger name="spawnpointtrigger" mode="xor" invert="true" >
+        <EventTrigger>
+            <events>
+                <trigger>
+                    <EventListener event=spawndelaytrigger1 />
+                </trigger>
+            </events>
+        </EventTrigger>
+        <EventTrigger invert="true">
+            <events>
+                <trigger>
+                    <EventListener event=portaltrigger />
+                </trigger>
+            </events>
+        </EventTrigger>
+    </Trigger>
 
     <!-- SPACE BOUNDARY -->
@@ -258,17 +283,15 @@
         </events>
     </PortalEndPoint>
-    <PortalEndPoint position="-72000,0,0" id="4" distance="40" target="MobileEntity" design="PortalDefault">
-        <attached>
-            <DistanceTrigger name="portaltrigger" position="0,0,0" target="Pawn" distance=10 stayActive="true" />
-            <DistanceTrigger name="portaldelaytrigger1" position="0,0,0" target="Pawn" distance=10 stayActive="true" delay=5 />
-            <DistanceTrigger name="portaldelaytrigger2" position="0,0,0" target="Pawn" distance=10 stayActive="true" delay=10 />
-            <DistanceTrigger name="portaldelaytrigger3" position="0,0,0" target="Pawn" distance=10 stayActive="true" delay=15 />
-            <DistanceTrigger name="portaldelaytrigger4" position="0,0,0" target="Pawn" distance=10 stayActive="true" delay=17 />
-        </attached>
-    </PortalEndPoint>
+    <PortalEndPoint position="-72000,0,0" id="4" distance="40" target="MobileEntity" design="PortalDefault" />
     <PortalLink fromID="3" toID="4" />
     <PortalLink fromID="4" toID="3" />
 
-    <SimpleNotification message="Moon orbit" >
+    <DistanceTrigger name="portaltrigger" position="-72000,0,0" target="Pawn" distance=10 stayActive="true" />
+    <DistanceTrigger name="portaldelaytrigger1" position="-72000,0,0" target="Pawn" distance=10 stayActive="true" delay=5 />
+    <DistanceTrigger name="portaldelaytrigger2" position="-72000,0,0" target="Pawn" distance=10 stayActive="true" delay=10 />
+    <DistanceTrigger name="portaldelaytrigger3" position="-72000,0,0" target="Pawn" distance=10 stayActive="true" delay=15 />
+    <DistanceTrigger name="portaldelaytrigger4" position="-72000,0,0" target="Pawn" distance=10 stayActive="true" delay=17 />
+
+    <SimpleNotification message="Welcome to Moon Orbit" >
         <events>
             <trigger>
@@ -281,5 +304,5 @@
         <events>
             <trigger>
-                <EventListener event=portaltrigger1 />
+                <EventListener event=portaldelaytrigger1 />
             </trigger>
         </events>
@@ -287,5 +310,6 @@
 
     <!-- MOON AREA -->
-    <!-- This is a model of our Moon: mass=MoonMass/1000 and radius=MoonRadius[km]*10 and position=DistanceFromEarth[km]*10 -->
+    
+    <!-- MOON -->
     <Planet
       position="-80000,0,0"
@@ -316,5 +340,5 @@
         <events>
             <trigger>
-                <EventListener event=portaltrigger2 />
+                <EventListener event=portaldelaytrigger2 />
             </trigger>
         </events>
@@ -322,5 +346,5 @@
 
     <!-- HYDROGEN FARMER & DOCKING -->
-    <SpaceShip position="-74000,2500,0" roll=90 yaw=180 pitch=20 mass=10000 >
+    <SpaceShip position="-74000,2500,0" roll=90 yaw=180 pitch=20 mass=10000 health=100000 >
       <attached>
         <!-- Docking -->
@@ -354,5 +378,5 @@
         </events>
         <attached>
-            <DistanceTrigger position="10,-202, -42" distance="400" target="Pawn"
+            <DistanceTrigger position="10,-202, -42" distance="800" target="Pawn"
                 beaconMode="exclude" targetname="bcnDestroyer" name="dockMe"
             />
@@ -371,5 +395,5 @@
         <events>
             <trigger>
-                <EventListener event=portaltrigger3 />
+                <EventListener event=portaldelaytrigger3 />
             </trigger>
         </events>
@@ -379,19 +403,62 @@
         <events>
             <trigger>
-                <EventListener event=portaltrigger4 />
-            </trigger>
-        </events>
-    </SimpleNotification>
-
-    <PickupSpawner position="25,50,-125" respawnTime="10" triggerDistance="20" maxSpawnedItems="5" visible="false">
+                <EventListener event=portaldelaytrigger4 />
+            </trigger>
+        </events>
+    </SimpleNotification>
+
+    <PickupSpawner position="-72487,420,-63" respawnTime="10" triggerDistance="20" maxSpawnedItems="5" active="false">
       <pickup>
-        <ShrinkPickup template ="mediumshrinkpickup"/>
+        <ShrinkPickup template ="smallshrinkpickup"/>
       </pickup>
       <events>
-        <visibility>
-            <EventListener event=portaltrigger3 />
-        </visibility>
+        <activity>
+            <EventListener event=portaldelaytrigger3 />
+        </activity>
       </events>
+      <attached>
+        <ParticleSpawner position="0,0,0" source="Orxonox/Shield" autostart="false" lifetime=500 loop=0 >
+            <events>
+                <spawn>
+                    <EventListener event=portaldelaytrigger3 />
+                </spawn>
+            </events>
+        </ParticleSpawner>
+      </attached>
     </PickupSpawner>
+
+    <SpaceBoundaries warnDistance="1" maxDistance="1700" showDistance="500" healthDecrease="0.1" position="-72369,803,2"/>
+    <SpaceBoundaries warnDistance="1" maxDistance="800" showDistance="300" healthDecrease="0.1" position="-73450,5067,-351"/>
+
+    <!-- FINISH -->
+
+    <DistanceTrigger name="dockingtrigger" position="-73942, 1288, -255" target="Pawn" distance=20 stayActive="true" />
+    <DistanceTrigger name="dockingdelaytrigger1" position="-73942, 1288, -255" target="Pawn" distance=20 stayActive="true" delay=3 />
+    <DistanceTrigger name="dockingdelaytrigger2" position="-73942, 1288, -255" target="Pawn" distance=20 stayActive="true" delay=10 />
+
+    <SimpleNotification message="Docking by Sven" >
+        <events>
+            <trigger>
+                <EventListener event=dockingtrigger />
+            </trigger>
+        </events>
+    </SimpleNotification>
+
+    <SimpleNotification message="Weapons by Jonas" >
+        <events>
+            <trigger>
+                <EventListener event=dockingdelaytrigger1 />
+            </trigger>
+        </events>
+    </SimpleNotification>
+
+    <SimpleNotification message="Steering enhancement by Manuel" >
+        <events>
+            <trigger>
+                <EventListener event=dockingdelaytrigger2 />
+            </trigger>
+        </events>
+    </SimpleNotification>
+    
   </Scene>
 </Level>
Index: code/branches/presentation/data/levels/spaceRace.oxw
===================================================================
--- code/branches/presentation/data/levels/spaceRace.oxw	(revision 8673)
+++ code/branches/presentation/data/levels/spaceRace.oxw	(revision 8679)
@@ -354,5 +354,5 @@
     </StaticEntity>
 
-    <!-- ---------------asteroid ellypse----------------- -->
+    <!-- ---------------asteroid ellipse----------------- -->
     <?lua
     max = 20
Index: code/branches/presentation/data/levels/templates/spaceshipAssff2.oxt
===================================================================
--- code/branches/presentation/data/levels/templates/spaceshipAssff2.oxt	(revision 8673)
+++ code/branches/presentation/data/levels/templates/spaceshipAssff2.oxt	(revision 8679)
@@ -31,5 +31,5 @@
 
    shakeFrequency = 15
-   shakeAmplitude = 7
+   shakeAmplitude = 9
 
    collisionType     = "dynamic"