Index: branches/script_engine/src/lib/script_engine/script.cc
===================================================================
--- branches/script_engine/src/lib/script_engine/script.cc	(revision 8680)
+++ branches/script_engine/src/lib/script_engine/script.cc	(revision 8681)
@@ -1,2 +1,17 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Silvan Nellen
+   co-programmer: Benjamin Grauer
+*/
+
 #include "script.h"
 #include "script_class.h"
Index: branches/script_engine/src/lib/script_engine/script.h
===================================================================
--- branches/script_engine/src/lib/script_engine/script.h	(revision 8680)
+++ branches/script_engine/src/lib/script_engine/script.h	(revision 8681)
@@ -1,2 +1,7 @@
+/*!
+ * @file scrip.h
+ *  wrapper for a lua_State
+ */
+
 #ifndef _SCRIPT_H
 #define _SCRIPT_H
Index: branches/script_engine/src/lib/script_engine/script_class.cc
===================================================================
--- branches/script_engine/src/lib/script_engine/script_class.cc	(revision 8680)
+++ branches/script_engine/src/lib/script_engine/script_class.cc	(revision 8681)
@@ -10,5 +10,5 @@
 
    ### File Specific:
-   main-programmer: ...
+   main-programmer: Benjamin Grauer
    co-programmer: ...
 */
Index: branches/script_engine/src/lib/script_engine/script_manager.cc
===================================================================
--- branches/script_engine/src/lib/script_engine/script_manager.cc	(revision 8680)
+++ branches/script_engine/src/lib/script_engine/script_manager.cc	(revision 8681)
@@ -1,2 +1,18 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Silvan Nellen
+   co-programmer: Benjamin Grauer
+*/
+
+
 #include <string>
 #include <list>
Index: branches/script_engine/src/lib/script_engine/script_manager.h
===================================================================
--- branches/script_engine/src/lib/script_engine/script_manager.h	(revision 8680)
+++ branches/script_engine/src/lib/script_engine/script_manager.h	(revision 8681)
@@ -1,2 +1,7 @@
+/*!
+ * @file scrip_manager.h
+ *  manages the scripts
+ */
+
 #ifndef _SCRIPT_MANAGER_H
 #define _SCRIPT_MANAGER_H
Index: branches/script_engine/src/lib/script_engine/script_method.cc
===================================================================
--- branches/script_engine/src/lib/script_engine/script_method.cc	(revision 8680)
+++ branches/script_engine/src/lib/script_engine/script_method.cc	(revision 8681)
@@ -10,5 +10,5 @@
 
    ### File Specific:
-   main-programmer: ...
+   main-programmer: Benjamin Grauer
    co-programmer: ...
 */
Index: branches/script_engine/src/lib/script_engine/script_method.h
===================================================================
--- branches/script_engine/src/lib/script_engine/script_method.h	(revision 8680)
+++ branches/script_engine/src/lib/script_engine/script_method.h	(revision 8681)
@@ -1,4 +1,4 @@
 /*!
- * @file script_class.h
+ * @file script_method.h
  * @brief Definition of ...
 */
Index: branches/script_engine/src/world_entities/script_trigger.cc
===================================================================
--- branches/script_engine/src/world_entities/script_trigger.cc	(revision 8680)
+++ branches/script_engine/src/world_entities/script_trigger.cc	(revision 8681)
@@ -1,2 +1,18 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Silvan Nellen
+   co-programmer: ...
+*/
+
+
 #include "script_trigger.h"
 #include "class_list.h"
Index: branches/script_engine/src/world_entities/script_trigger.h
===================================================================
--- branches/script_engine/src/world_entities/script_trigger.h	(revision 8680)
+++ branches/script_engine/src/world_entities/script_trigger.h	(revision 8681)
@@ -1,2 +1,7 @@
+/*!
+ * @file scrip_trigger.h
+ *  triggeres a script
+ */
+
 #ifndef _SCRIPT_TRIGGER_H
 #define _SCRIPT_TRIGGER_H