Index: code/branches/presentation/src/libraries/network/synchronisable/Synchronisable.h
===================================================================
--- code/branches/presentation/src/libraries/network/synchronisable/Synchronisable.h	(revision 8692)
+++ code/branches/presentation/src/libraries/network/synchronisable/Synchronisable.h	(revision 8694)
@@ -50,4 +50,5 @@
   namespace ObjectDirection{
     enum Value{
+      None=0x0,
       ToClient=0x1,
       ToServer=0x2,
Index: code/branches/presentation/src/modules/notifications/dispatchers/SimpleNotification.cc
===================================================================
--- code/branches/presentation/src/modules/notifications/dispatchers/SimpleNotification.cc	(revision 8692)
+++ code/branches/presentation/src/modules/notifications/dispatchers/SimpleNotification.cc	(revision 8694)
@@ -51,5 +51,5 @@
         this->setSender("simpleNotification");
 
-        this->setSyncMode(0x0);
+        this->setSyncMode(ObjectDirection::None);
     }
 
Index: code/branches/presentation/src/modules/objects/SpaceBoundaries.cc
===================================================================
--- code/branches/presentation/src/modules/objects/SpaceBoundaries.cc	(revision 8692)
+++ code/branches/presentation/src/modules/objects/SpaceBoundaries.cc	(revision 8694)
@@ -106,4 +106,5 @@
             Billboard* billboard = new Billboard(this);
             billboard->setPosition(position);
+            billboard->setSyncMode(ObjectDirection::None);
             this->setBillboardOptions(billboard);
             BillboardAdministration ba = {true, billboard};
Index: code/branches/presentation/src/modules/objects/triggers/MultiTrigger.cc
===================================================================
--- code/branches/presentation/src/modules/objects/triggers/MultiTrigger.cc	(revision 8692)
+++ code/branches/presentation/src/modules/objects/triggers/MultiTrigger.cc	(revision 8694)
@@ -63,5 +63,5 @@
         this->bMultiTrigger_ = true;
 
-        this->setSyncMode(0x0);
+        this->setSyncMode(ObjectDirection::None);
     }
 
Index: code/branches/presentation/src/modules/objects/triggers/Trigger.cc
===================================================================
--- code/branches/presentation/src/modules/objects/triggers/Trigger.cc	(revision 8692)
+++ code/branches/presentation/src/modules/objects/triggers/Trigger.cc	(revision 8694)
@@ -76,5 +76,5 @@
         }
 
-        this->setSyncMode(0x0);
+        this->setSyncMode(ObjectDirection::None);
     }
 
Index: code/branches/presentation/src/modules/objects/triggers/TriggerBase.cc
===================================================================
--- code/branches/presentation/src/modules/objects/triggers/TriggerBase.cc	(revision 8692)
+++ code/branches/presentation/src/modules/objects/triggers/TriggerBase.cc	(revision 8694)
@@ -71,5 +71,5 @@
         this->bMultiTrigger_ = false;
 
-        this->setSyncMode(0x0);
+        this->setSyncMode(ObjectDirection::None);
     }
 
Index: code/branches/presentation/src/modules/pickup/PickupRepresentation.cc
===================================================================
--- code/branches/presentation/src/modules/pickup/PickupRepresentation.cc	(revision 8692)
+++ code/branches/presentation/src/modules/pickup/PickupRepresentation.cc	(revision 8694)
@@ -57,5 +57,5 @@
 
         this->initialize();
-        this->setSyncMode(0x0); // The default PickupRperesentation created by each PickupManager is not synchronised, since it only exists locally.
+        this->setSyncMode(ObjectDirection::None); // The default PickupRperesentation created by each PickupManager is not synchronised, since it only exists locally.
     }
 
Index: code/branches/presentation/src/orxonox/collisionshapes/WorldEntityCollisionShape.cc
===================================================================
--- code/branches/presentation/src/orxonox/collisionshapes/WorldEntityCollisionShape.cc	(revision 8692)
+++ code/branches/presentation/src/orxonox/collisionshapes/WorldEntityCollisionShape.cc	(revision 8694)
@@ -43,5 +43,5 @@
         this->worldEntityOwner_ = creator;
         // suppress synchronisation
-        this->setSyncMode(0x0);
+        this->setSyncMode(ObjectDirection::None);
     }
 
Index: code/branches/presentation/src/orxonox/graphics/Camera.cc
===================================================================
--- code/branches/presentation/src/orxonox/graphics/Camera.cc	(revision 8692)
+++ code/branches/presentation/src/orxonox/graphics/Camera.cc	(revision 8694)
@@ -71,5 +71,5 @@
         this->lastDtLagged_ = false;
 
-        this->setSyncMode(0x0);
+        this->setSyncMode(ObjectDirection::None);
 
         this->setConfigValues();
Index: code/branches/presentation/src/orxonox/weaponsystem/WeaponSlot.cc
===================================================================
--- code/branches/presentation/src/orxonox/weaponsystem/WeaponSlot.cc	(revision 8692)
+++ code/branches/presentation/src/orxonox/weaponsystem/WeaponSlot.cc	(revision 8694)
@@ -46,5 +46,5 @@
         this->weapon_ = 0;
 
-        this->setSyncMode(0x0);
+        this->setSyncMode(ObjectDirection::None);
     }
 
Index: code/branches/presentation/src/orxonox/worldentities/CameraPosition.cc
===================================================================
--- code/branches/presentation/src/orxonox/worldentities/CameraPosition.cc	(revision 8692)
+++ code/branches/presentation/src/orxonox/worldentities/CameraPosition.cc	(revision 8694)
@@ -46,5 +46,5 @@
         this->bRenderCamera_ = false;
 
-        this->setSyncMode(0x0);
+        this->setSyncMode(ObjectDirection::None);
     }
 
Index: code/branches/presentation/src/orxonox/worldentities/SpawnPoint.cc
===================================================================
--- code/branches/presentation/src/orxonox/worldentities/SpawnPoint.cc	(revision 8692)
+++ code/branches/presentation/src/orxonox/worldentities/SpawnPoint.cc	(revision 8694)
@@ -50,5 +50,5 @@
             COUT(1) << "Error: SpawnPoint has no Gametype" << std::endl;
 
-        this->setSyncMode(0x0);
+        this->setSyncMode(ObjectDirection::None);
     }
 